#include "RL_Interface.h"
#include "gnu.h"
#include "RL_util.h"
#include <time.h>
#include <stdio.h>

/*
 * Fichier de RL-glue modifie pour la cause par Pierre Gerard pierre.gerard@lipn.univ-paris13.fr
 */

time_t start;
time_t stop;

void run(int num_episodes)
{
	for(int x=0; x < num_episodes; x++)
	{
		printf("Episode %d : \n",x);
		RL_episode();			 //run a single episode
		fflush(stdout);
		collectStats();			 //collect stats on episode
	}
}


void startTimer(time_t *strt)
{
	time(strt);
}


void endTimer(time_t *stp)
{
	time(stp);
}


void printTimeTaken()
{
	int time = (int)(stop - start);
	printf("\n**************************************************************\n");
	printf("Time taken to complete the run: %d seconds\n",time);
	printf("**************************************************************\n");
}


int main(int argc, char *argv[])
{
	int num_episodes = 0;

	if (argc!=2)
	{
		printf("Usage : RL_main {nombre d'episodes}\n\n");
		exit(1);
	}

	num_episodes = atoi(argv[1]);

	printf("\n**************************************************************\n");
	printf("Apprentissage sur %d épisodes\n",num_episodes);
	printf("**************************************************************\n");
	startTimer(&start);
	RL_init();			//initialize interface
	initStats(num_episodes);	//initialize stats routine

	run(num_episodes);		//run experiment

	endTimer(&stop);

	printTimeTaken();
	RL_cleanup();

	exit(0);
}
