/*
 * Bas sur SarsaAgent.h de par Anna Koop
 * Auteur : Pierre Grard
 *
 * Agent Q(0)
 * Etats : int* (tableau d'attributs entiers)
 * Actions : int (attribut entier)
 */

#ifndef DYNAQAGENT_H
#define DYNAQAGENT_H

#include <iostream>
#include <cstdlib>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "C_agent_parser.h"
#include "RLcommon.h"

Action act;
Action a;

int nb_simul;

int egreedy(int s);
int argmax(int s);

void simulate_actions();

double Rew(int sta, int act);
double Trn(int s0, int act, int s1);

// *******************************************************************************************
//tabular sarsa agent, no discounting

int n;							 //number of states
int m;							 //number of actions
int nm;							 //the length of the state-action value array
int A;							 //index of last action taken
int S;							 //index of last state/sensation observed
double **Q;						 //array of action values
int *actions;					 //array of possible actions
double alpha;					 //step-size parameter
double epsilon;					 //exploration probability parameter

long*** Tnb;
long** Ttot;
double** Rsum;
long** Rtot;

int obs_dim;					 // nombre de dimensions des observations
int *obs_sizes;					 // pour stocker le nombre de valeurs possibles dans chaque dimension
// *******************************************************************************************
#endif
