/*
 * Cr  partir de catMouse.cpp (voir le site de RL-Glue)
 * Auteur de cette version : Pierre Grard pierre.gerard@lipn.univ-paris13.fr
 *
 * Environnement de type Gridworld avec des obstacles, des trous de souris, un chat et du fromage
 * Le chat ne peut pas accder aux cases "trou de souris"
 * Le chat est egreedy en regard du rapprochement de la souris
 *
 * Observations : int*
 * - int[0] : colonne de l'agent souris
 * - int[1] : ligne de l'agent souris
 * - int[2] : colonne du chat
 * - int[3] : ligne du chat
 * Actions : int
 * - 0..7 pour les huit directions
 * Rcompense : float, typiquement, on met
 * - -10 si la souris et le chat se trouvent sur la mme case
 * - +5 si la souris se trouve sur une case fromage
 *
 * Tche pisodique : un pisode se termine quand le chat et la souris sont sur la mme case (RIP la souris)
 * Chaque pisode, le point de dpart est choisi alatoirement
 */

#ifndef CATMOUSE_H
#define CATMOUSE_H

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include "RLcommon.h"

int row, col;
int mx, my;
int cx, cy;
int chx, chy;

int cheeseReward, deathPenalty;
double epsilon_cat;

int** walls;

typedef struct
{
	int width;
	int height;
} Dimension;

Dimension moveMouse(int action);
Dimension moveCat(int catX, int catY, int mouseX, int mouseY);
void setRandomPos();
Dimension getRandomPos();
bool legal(int x, int y);
void changeCheese();
void removeCheese();
void setRandomCheese();

Observation o = new int[5];
Reward_observation ro;			 //instance of observation type

void env_print();
#endif
