/*
 *  mine_common.h
 *
 *
 *  Created by Adam White on Fri Aug 05 2005.
 *  Copyright (c) 2005 UAlberta. All rights reserved.
 *
 *  A simple grid world with stationary mines.
 *  Episodic task, end of episode when find goal or hit mine
 *
 *  State: 1D discrete
 *  Actions: 1D discrete (0,1,2,3)
 *
 */
#ifndef CAT_COMMON_H
#define CAT_COMMON_H

#define AGENT_INIT
#define ENV_INIT
#define AGENT_CLEANUP
#define ENV_CLEANUP

// An action is an integer
// 0 -> player hits
// 1 -> player sticks
typedef int Action;
typedef int* Observation;

typedef char* Task_specification;
typedef double Reward;

typedef struct
{
	Reward r;
	Observation o;
	bool terminal;
} Reward_observation;

typedef int State_key;
typedef int Random_seed_key;
#endif
