/*
 * Cr  partir de Mines.h par Adam White (Fri Aug 05 2005.)
 * Auteur : Pierre Grard pierre.gerard@lipn.univ-paris13.fr
 *
 * Environnement de type Gridworld avec des mines, des obstacles et un but
 * Les grilles sont gnres alatoirement
 *
 * Observations : int*
 * - int[0] : colonne de l'agent dans la grille
 * - int[1] : ligne de l'agent dans la grille
 * Actions : int
 * - 0,1,2,3 pour quatre directions
 * Rcompense : float
 * - 10 si le but est atteint
 * - -1 si l'agent passe sur une mine
 * - 0 sinon
 *
 * Tche pisodique : un pisode se termine quand l'agent atteint le but
 * Chaque pisode, le point de dpart est choisi alatoirement
 */

#ifndef GRIDWORLD_H
#define GRIDWORLD_H

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include "RLcommon.h"

int* getPosition();
int* getNextPosition(int action);
Reward getReward();
void env_print();

typedef struct
{
	int START;					 //Start marker in grid
	int GOAL;					 //End marker in grid
	int LAND;					 //Free space in grid
	int OBSTACLE;				 //Obstical in grid
	int MINE;					 //Mine in grid
	int row;					 //Number of rows in grid
	int col;					 //Number of columns in grid
	int startRow;				 //Starting position
	int startCol;				 //Starting position
	int agentRow;				 //Agents current position
	int agentColumn;			 //Agents current position
	int mx;
	int my;

} mine_env;

int cc;
int env_map[100][100];

Observation o = new int[2];
mine_env M;						 //mine struct
Reward_observation ro;			 //instance of observation type

bool env_terminal;
#endif
