/*
 * Cr  partir de Mines_common.cpp par Adam White (Fri Aug 05 2005.)
 * Auteur : Pierre Grard pierre.gerard@lipn.univ-paris13.fr
 *
 * Environnement de type Gridworld avec des mines, des obstacles et un but
 * Les grilles sont gnres alatoirement
 *
 * Observations : int*
 * - int[0] : colonne de l'agent dans la grille
 * - int[1] : ligne de l'agent dans la grille
 * Actions : int
 * - 0,1,2,3 pour quatre directions
 * Rcompense : float
 * - 10 si le but est atteint
 * - -1 si l'agent passe sur une mine
 * - 0 sinon
 *
 * Tche pisodique : un pisode se termine quand l'agent atteint le but
 * Chaque pisode, le point de dpart est choisi alatoirement
 */

#ifndef MINE_COMMON_H
#define MINE_COMMON_H

//This tells interface that you will provide definitions for optional functions: env_init, agent_init, and agent_clean.
//See DOC for list of optional functions and flags that allow implementation of some or all of these methods
#define AGENT_INIT
#define ENV_INIT
#define AGENT_CLEANUP
#define ENV_CLEANUP

//#define ENV_STATE
//#define ENV_RANDOM

#include <vector>
typedef int* Observation;		 //Defining what type a Observation is
typedef int Action;				 //Defining what type a action is

typedef char* Task_specification;
typedef double Reward;

typedef struct
{
	Reward r;
	Observation o;
	bool terminal;
} Reward_observation;

typedef int State_key;
typedef int Random_seed_key;
#endif
