/*
 *  MountainCar.h
 *
 *  Created by Rich Sutton, modified by Adam White on September 20 2005.
 *  Copyright (c) 2005 UAlberta. All rights reserved.
 *
 *  Description.
 *		This file contains a simulation of the mountain and car dynamic system
 *		EPISODIC
 *
 *  State: 2D Continous
 *  Actions: 1D discrete (0 1 2)
 */
#ifndef MOUNTAINCAR_H
#define MOUNTAINCAR_H

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <math.h>
#include <unistd.h>
#include "RLcommon.h"

//State variables
double mcar_position;
double mcar_velocity;

int numActions = 3;
int stateSize = 2;

//Step variables
#define mcar_min_position -1.2
#define mcar_max_position 0.6
#define mcar_max_velocity 0.07	 // the negative of this is also the minimum velocity
#define mcar_goal_position 0.5
#define POS_WIDTH (1.7 / 8)		 // the tile width for position
#define VEL_WIDTH (0.14 / 8)	 // the tile width for velocity

bool mcar_goal();	
void env_print(Action action);			 // Is Car within goal region?

Observation o;					 //instance of Sensation type
Reward_observation ro;			 //instance of observation type
#endif
