/*
 *  carAgent.h
 *
 *
 *  Created by Adam White on 24/02/06.
 *  Copyright 2006 __MyCompanyName__. All rights reserved.
 *
 */
#include <iostream>
#include "tiles.h"
#include "stdio.h"
#include "stdlib.h"
#include <fcntl.h>
#include <string.h>
#include <unistd.h>
#include <math.h>
#include "RLcommon.h"
#include "C_agent_parser.h"

int obs_dim;
double* obs_width;
double* obs_min;
double* obs_max;
double* tile_width;

int grid_size;

int num_actions;
int min_action;
int max_action;

#define MEMORY_SIZE 64000		 // number of parameters to theta, memory size
#define NUM_TILINGS 2 //14
int num_tilings ;
#define MAX_NONZERO_TRACES 6400
int nonzero_traces[MAX_NONZERO_TRACES];
int num_nonzero_traces = 0;
int nonzero_traces_inverse[MEMORY_SIZE];
float minimum_trace = 0.01;

double h[MEMORY_SIZE];
double b[MEMORY_SIZE];
double al[MEMORY_SIZE];
double th;
double tmp;

// Global RL variables:
double* Q;			 // action values
int feats[MEMORY_SIZE];
double theta[MEMORY_SIZE];		 // modifyable parameter vector, aka memory, weights
double e[MEMORY_SIZE];			 // eligibility traces
int** F; // sets of features, one set per action

float* state_vars;			 //temp array
double* oldO;

float epsilon ;			 // probability of random action
float alpha ;				 // step size parameter
float lambda ;			 // trace-decay parameters
//float gamma ;				 // discount-rate parameters

int oldAction;					 //action selected on previous time step
int newAction;					 //action selected on current time step

void loadQ();					 // compute action values for current theta, F
void loadQ(int a);				 // compute one action value for current theta, F
void loadF(double* oo);		 // compute feature sets for current state
								 // compute argmax action from Q
int argmax(double* Q);

void ClearTrace(int f);			 // clear or zero-out trace, if any, for given feature
								 // clear trace at given location in list of nonzero-traces
void ClearExistentTrace(int f, int loc);

								 // decay all nonzero traces
void DecayTraces(float decay_rate);
								 // set trace to given value
void SetTrace(int f, float new_trace_value);
void IncreaseMinTrace();		 // increase minimal trace value, forcing more to 0, making room for new ones
